from vtool import qt
from vtool import qt_ui

class NodeWindow(qt_ui.BasicGraphicsWindow):
    def __init__(self):
        super(NodeWindow, self).__init__()
        self.setWindowTitle('Noodles')
        
    def _define_main_view(self):
        self.main_view = NodeView()
        self.main_layout.addWidget(self.main_view)
        
    def _build_widgets(self):
        pass
        #menu = SideMenu()
        #self.main_layout.addWidget(menu)
        
        
        
class NodeView(qt_ui.BasicGraphicsView):
    
    def __init__(self, parent = None):
        super(NodeView, self).__init__(parent)
        
        self._zoom = 1
        self.drag = False
        
        self.setRenderHints(qt.QPainter.Antialiasing | qt.QPainter.HighQualityAntialiasing)
        
        brush = qt.QBrush()
        brush.setColor(qt.QColor(15,15,15,1))
        self.setBackgroundBrush(brush)
        #self.setRenderHints(qt.QPainter.Antialiasing | qt.QPainter.SmoothPixmapTransform | qt.QPainter.HighQualityAntialiasing)

        #self.main_scene.addItem(FkItem())
        self.main_scene.addItem(NodeSocket())

    def drawBackground(self, painter, rect):
        
        
        
        
        pixmap = qt.QPixmap(40, 40)
        pixmap.fill(qt.QtCore.Qt.transparent)
        
        pix_painter = qt.QPainter(pixmap)
        pix_painter.setBrush(qt.QColor.fromRgbF(.15, .15, .15, 1))
        
        pen = qt.QPen()
        pen.setStyle(qt.Qt.NoPen)
        pix_painter.setPen(pen)
        pix_painter.drawRect(0,0,40,40)
        
        
        pen = qt.QPen()
        pen.setColor(qt.QColor.fromRgbF(0, 0, 0, .25))
        pen.setStyle(qt.Qt.SolidLine)
        
        pix_painter.setPen(pen)
        
        pix_painter.drawLine(0,0,5,0)
        pix_painter.drawLine(0,0,0,5)
        pix_painter.drawLine(35,0,40,0)
        pix_painter.drawLine(0,35,0,40)
        
        
        #pix_painter.drawEllipse(0,0,40,40)
        
        pix_painter.end()

        #background_brush = qt.QBrush(pixmap)
        
        
        
        painter.fillRect(rect, pixmap)      

    def _define_main_scene(self):
        self.main_scene = NodeScene()
        
        self.main_scene.setObjectName('main_scene')
        self.main_scene.setSceneRect(0,0,5000,5000)
        
        self.setScene(self.main_scene)   

    def keyPressEvent(self, event):
        
        items = self.main_scene.selectedItems()
        
        if event.key() == qt.Qt.Key_F:
            
            
            position = items[0].pos()
            #position = self.mapToScene(items[0].pos())
            self.centerOn(position)
            
        if event.key() == qt.Qt.Key_Delete:
            for item in items:
                self.main_scene.removeItem(item)
            print 'delete!!!'   
            
        super(NodeView, self).keyPressEvent(event)

    def wheelEvent(self, event):
        """
        Zooms the QGraphicsView in/out.
        
        """
        
        if self._zoom < 0.5 or self._zoom > 2:
            return
        
        inFactor = 1.25
        outFactor = 1 / inFactor
        oldPos = self.mapToScene(event.pos())
        if event.delta() > 0:
            zoomFactor = inFactor
        else:
            zoomFactor = outFactor
        
        self._zoom *= zoomFactor
        
        if self._zoom < 0.5:
            self._zoom = 0.5
            return
        if self._zoom > 2.0:
            self._zoom = 2.0
            return
        
        
        
        self.scale(zoomFactor, zoomFactor)
        newPos = self.mapToScene(event.pos())
        delta = newPos - oldPos
        self.translate(delta.x(), delta.y())

    def mousePressEvent(self, event):
        if event.button() == qt.QtCore.Qt.MiddleButton:
            self.setDragMode(qt.QGraphicsView.NoDrag)
            self.drag = True
            self.prevPos = event.pos()
            self.setCursor(qt.QtCore.Qt.SizeAllCursor)
        elif event.button() == qt.QtCore.Qt.LeftButton:
            pass
            self.setDragMode(qt.QGraphicsView.RubberBandDrag)
            #self.setDragMode(qt.QGraphicsView.RubberBandDrag)
            super(NodeView, self).mousePressEvent(event)
        

    def mouseMoveEvent(self, event):
        
        if self.drag:
            
            delta = (event.pos() - self.prevPos) * -1.0
            
            center = qt.QtCore.QPoint(self.viewport().width()/2.0 + delta.x(), self.viewport().height()/2.0 + delta.y())
            
            newCenter = self.mapToScene(center)
            
            self.centerOn(newCenter)
            self.prevPos = event.pos()
            return
        
        super(NodeView, self).mouseMoveEvent(event)

    def mouseReleaseEvent(self, event):
        if self.drag:
            self.drag = False
            self.setCursor(qt.QtCore.Qt.ArrowCursor)
            self.setDragMode(qt.QGraphicsView.RubberBandDrag)
        super(NodeView, self).mouseReleaseEvent(event) 
        

    def contextMenuEvent(self, event):
        super(NodeView, self).contextMenuEvent(event)
        
        if not event.isAccepted():
        
            self._build_context_menu(event)
        
        
    def _build_context_menu(self, event):
        print 'build menu'
        self.menu = qt.QMenu()
        
        item_action_dict = {}
        
        self.menu.addSeparator()
        
        for node_name in register_item:
            
            print node_name
            
            item_action = qt.QAction(node_name, self.menu)
            self.menu.addAction(item_action)
            
            item_action_dict[item_action] = node_name
        
        self.menu.addSeparator()    
                
        action = self.menu.exec_(event.globalPos())
        
        pos = event.pos()
        pos = self.mapToScene(pos)
        
        if action in item_action_dict:
            node_name = item_action_dict[action]
            self.add_rig_item(node_name, pos)
            
    
    def add_rig_item(self, name, position):
        
        if name in register_item:
            
            item_inst = register_item[name](name)
            self.main_scene.addItem(item_inst)
            #item_inst.setPos(position)
            item_inst.setPos(position)    
        
        #box.setPos(window.main_view.main_scene.width()/2.0, window.main_view.main_scene.height()/2.0)
        
        
        
class NodeScene(qt.QGraphicsScene):      
    
    disconnect = qt_ui.create_signal(object)
    
       
            
        
class SideMenu(qt.QFrame):
    def __init__(self, parent = None):
        super(SideMenu, self).__init__(parent)
        self.setObjectName('side_menu')
        self._build_widgets()

    def _build_widgets(self):
        # Frame.
        self.setFixedWidth(200)
        
        
        self.main_layout = qt.QVBoxLayout(self)
        self.main_layout.setAlignment(qt.Qt.AlignCenter)

        # Buttons.
        self.add_fk = qt.QPushButton('Add Fk Rig')
        self.add_ik = qt.QPushButton('Add Ik Rig')
        self.add_joints = qt.QPushButton('Add Joints')
        self.main_layout.addWidget(self.add_fk)
        self.main_layout.addWidget(self.add_ik)
        self.main_layout.addWidget(self.add_joints)

        self._init_connections()

    def _init_connections(self):
        self.add_fk.clicked.connect(self._add_fk_rig)
        self.add_ik.clicked.connect(self._add_ik_rig)
        self.add_joints.clicked.connect(self._add_joints)
    
    def _add_joints(self):
        window = self.window()
        box = NodeItem('Joints')
        window.main_view.main_scene.addItem(box)
        #box.setGraphicsEffect(window.main_view.drop_shadow)
        box.setPos(window.main_view.main_scene.width()/2.0, window.main_view.main_scene.height()/2.0)
        
    def _add_ik_rig(self):
        window = self.window()
        box = NodeItem('IK Rig')
        window.main_view.main_scene.addItem(box)
        #box.setGraphicsEffect(window.main_view.drop_shadow)
        box.setPos(window.main_view.main_scene.width()/2.0, window.main_view.main_scene.height()/2.0)

    def _add_fk_rig(self):
        window = self.window()
        box = NodeItem('FK Rig')
        window.main_view.main_scene.addItem(box)
        #box.setGraphicsEffect(window.main_view.drop_shadow)
        box.setPos(window.main_view.main_scene.width()/2.0, window.main_view.main_scene.height()/2.0)
        

                

    
class NodeLine(qt.QGraphicsPathItem):
    
    disconnected = qt_ui.create_signal(object)
    
    def __init__(self, pointA, pointB):
        super(NodeLine, self).__init__()
        self._pointA = pointA
        self._pointB = pointB
        self._source = None
        self._target = None
        #self.setZValue(-1)
        
        self.brush = qt.QBrush()
        self.brush.setStyle(qt.QtCore.Qt.SolidPattern)
        self.brush.setColor(qt.QColor(200,200,200,150))
        
        
        self.pen = qt.QPen()
        self.pen.setStyle(qt.QtCore.Qt.SolidLine)
        self.pen.setWidth(2)
        self.pen.setColor(qt.QColor(200,200,200,150))
        self.setPen(self.pen)

    def mousePressEvent(self, event):
        self.pointB = event.pos()

    def mouseMoveEvent(self, event):
        self.pointB = event.pos()
        
    def mouseReleaseEvent(self, event):
        self.scene().disconnect.emit(self)
        

    def updatePath(self):
        path = qt.QPainterPath()
        path.moveTo(self.pointA)
        dx = self.pointB.x() - self.pointA.x()
        dy = self.pointB.y() - self.pointA.y()
        #ctrl1 = qt.QtCore.QPointF(self.pointA.x() + dx * 0.25, self.pointA.y() + dy * 0.1)
        #ctrl2 = qt.QtCore.QPointF(self.pointA.x() + dx * 0.75, self.pointA.y() + dy * 0.9)
        ctrl1 = qt.QtCore.QPointF(self.pointA.x() + dx * 0.5, self.pointA.y() + dy * 0.1)
        ctrl2 = qt.QtCore.QPointF(self.pointA.x() + dx * 0.5, self.pointA.y() + dy * 0.9)
        
        path.cubicTo(ctrl1, ctrl2, self.pointB)
        self.setPath(path)

    def paint(self, painter, option, widget):
        
        
        painter.setPen(self.pen)
        painter.drawPath(self.path())
        
        painter.setBrush(self.brush)
        painter.drawEllipse(self.pointB.x() - 2,self.pointB.y() - 2 ,4,4)

    @property
    def pointA(self):
        return self._pointA

    @pointA.setter
    def pointA(self, point):
        self._pointA = point
        self.updatePath()

    @property
    def pointB(self):
        return self._pointB

    @pointB.setter
    def pointB(self, point):
        self._pointB = point
        self.updatePath()

    @property
    def source(self):
        return self._source

    @source.setter
    def source(self, widget):
        self._source = widget

    @property
    def target(self):
        return self._target

    @target.setter
    def target(self, widget):
        self._target = widget

#--- nodes

class NodeItem(qt.QGraphicsItem):
    def __init__(self, name = ''):
        self._current_socket_pos = 0
        
        super(NodeItem, self).__init__()
        self.name = name
        
        self._output = None
        self._input = None
        self.rect = qt.QtCore.QRect(0,0,150,40)
        self.setFlag(qt.QGraphicsItem.ItemIsMovable)
        self.setFlag(qt.QGraphicsItem.ItemIsSelectable)
        
        
        # Brush.
        self.brush = qt.QBrush()
        self.brush.setStyle(qt.QtCore.Qt.SolidPattern)
        self.brush.setColor(qt.QColor(90,90,90,255))

        # Pen.
        self.pen = qt.QPen()
        self.pen.setStyle(qt.QtCore.Qt.SolidLine)
        self.pen.setWidth(1)
        self.pen.setColor(qt.QColor(20,20,20,255))

        self.selPen = qt.QPen()
        self.selPen.setStyle(qt.QtCore.Qt.SolidLine)
        self.selPen.setWidth(3)
        self.selPen.setColor(qt.QColor(255,255,255,255))
        
        self._in_sockets = []
        self._out_sockets = []
        
        self._build_items()
    """
    def shape(self):
        path = qt.QPainterPath()
        path.addRect(self.boundingRect())
        return path
    """
    
    def _build_items(self):
        #self.add_socket(socket_type, data_type, name)
        pass
        
    def boundingRect(self):
        return qt.QtCore.QRectF(self.rect)

    def paint(self, painter, option, widget):
        painter.setBrush(self.brush)
        if self.isSelected():
            painter.setPen(self.selPen)
        else:
            painter.setPen(self.pen)
        
        painter.drawRoundedRect(self.rect, 10,10)
        
        pen = qt.QPen()
        pen.setStyle(qt.QtCore.Qt.SolidLine)
        pen.setWidth(1)
        pen.setColor(qt.QColor(255,255,255,255))   
        painter.setPen(pen)     
        painter.drawText(0,-10,self.name )
        #painter.drawRect(self.rect)

    def mouseMoveEvent(self, event):
        super(NodeItem, self).mouseMoveEvent(event)
        
        for socket in self._out_sockets:
            if socket.out_lines:
                for line in socket.out_lines:
                    line.pointA = line.source.get_center()
                    line.pointB = line.target.get_center()
        
        for socket in self._in_sockets:
            if socket.in_lines:
                for line in socket.in_lines:
                    line.pointA = line.source.get_center()
                    line.pointB = line.target.get_center()

    def contextMenuEvent(self, event):
        self._build_context_menu(event)
        event.setAccepted(True)
        
    def _build_context_menu(self, event):
        
        menu = qt.QMenu()
        
        add_socket = menu.addAction('add socket')
        
        selected_action = menu.exec_(event.screenPos())
        """
        make = menu.addAction('make')
        makeFromHere = menu.addAction('make from here')
        debugConnections = menu.addAction('debug connections')
        

        if selectedAction == debugConnections:
            print 'Input'
            for socket in self._in_sockets:
                for idx,line in enumerate(socket.in_lines):
                    print '  Line {0}'.format(idx)
                    print '    pointA: {0}'.format(line.pointA)
                    print '    pointB: {0}'.format(line.pointB)
            print 'Output'
            for socket in self._out_sockets:
                for idx,line in enumerate(socket.out_lines):
                    print '  Line {0}'.format(idx)
                    print '    pointA: {0}'.format(line.pointA)
                    print '    pointB: {0}'.format(line.pointB)
        """
        if selected_action == add_socket:
            print 'here'
            
            self.add_socket('in', '','goo')
            self.add_socket('out', '','foo')
         
    def _add_space(self, item):
        
        if self._current_socket_pos > 0:
            height = self.rect.height()
            height += 20
        
            self.rect = qt.QtCore.QRect(0,0,150,height)
        
            item.setY(self._current_socket_pos*20)
            
        self._current_socket_pos += 1
             
    def add_socket(self, socket_type, data_type, name):
        
        
        socket = NodeSocket(socket_type, data_type, name)
        socket.setParentItem(self)
        
        if socket_type == 'out':
            self._out_sockets.append(socket)        
        
        if socket_type == 'in':
            self._in_sockets.append(socket)
            
        
        self._add_space(socket)
            
        #self.update()
        
        
        
        
    def add_line_edit(self):
        
        text_entry = qt.QLineEdit()
        text_entry.setMaximumWidth(130)
        text_entry.setMaximumHeight(20)
        text_entry.setPlaceholderText('joint search')
        #text_entry.setEchoMode(text_entry.NoEcho)
        proxy_widget = qt.QGraphicsProxyWidget(self)
        proxy_widget.setWidget(text_entry)
        proxy_widget.setPos(10,10)
        
        
        self._add_space(proxy_widget)
        
        #return proxy_widget
        

class JointsItem(NodeItem):
    def _build_items(self):
        
        
        
        self.add_line_edit()
        self.add_socket('out', 'transform', 'Joints')
        #self.add_socket(socket_type, data_type, name)
        

class RigItem(NodeItem):
    pass

class FkItem(RigItem):
    
    def _build_items(self):
        
        self.add_socket('in', 'transform', 'Joints')
        self.add_socket('out', 'transform', 'Controls')


#--- sockets

class NodeSocket(qt.QGraphicsItem):

    def __init__(self, socket_type = 'in', data_type = 'None',  name = 'None'):
        
        self.name = name
        
        super(NodeSocket, self).__init__()
        
        #self._data_type = data_type
        
        self._socket_type = socket_type

        self.rect = qt.QtCore.QRect(0,0,0,0)        
        if socket_type == 'in':
            self.rect = qt.QtCore.QRect(-2, 12.5, 20,20)
        if socket_type == 'out':
            self.rect = qt.QtCore.QRect(148, 12.5, 20,15)
        
        

        # Brush.
        self.brush = qt.QBrush()
        
        self.brush.setStyle(qt.QtCore.Qt.SolidPattern)
        self.brush.setColor(qt.QColor(180,180,180,255))

        # Pen.
        self.pen = qt.QPen()
        self.pen.setStyle(qt.QtCore.Qt.SolidLine)
        self.pen.setWidth(1)
        self.pen.setColor(qt.QColor(20,20,20,255))

        # Lines.
        self.out_lines = []
        self.in_lines = []
    
    #def shape(self):
    #    path = qt.QPainterPath()
        
        #path.addRoundRect(self.boundingRect(),2)
    #    path.addEllipse(self.boundingRect())
    #    return path
    
    def set_y_position(self, value):
        self.setY(value)
        

    def boundingRect(self):
        return qt.QtCore.QRectF(self.rect)

    def paint(self, painter, option, widget):
        painter.setBrush(self.brush)
        painter.setPen(self.pen)
        

        
        if self._socket_type == 'in':       
            self.brush.setColor(qt.QColor(60,60,60,255)) 
            painter.setBrush(self.brush)
            painter.drawText(qt.QtCore.QPoint(30,25),self.name)
            painter.drawEllipse(self.rect)
        if self._socket_type == 'out':
            
            #name_len = len(self.name)
            
            name_len = painter.fontMetrics().width(self.name)
            offset = 140 - name_len
            painter.drawText(qt.QtCore.QPoint(offset,25),self.name)

        
            poly = qt.QPolygon()
            poly << qt.QtCore.QPoint(0,0) << qt.QtCore.QPoint(0,16) << qt.QtCore.QPoint(20,10) << qt.QtCore.QPoint(20,6)
            poly.translate(self.rect.x(), self.rect.y())
            painter.drawPolygon(poly)
        
        #painter.drawRect(self.rect)
        #painter.drawText(self.rect,self.name)
        #painter.drawRoundedRect(self.rect,5,5)
        #painter.drawEllipse(self.rect)

    def mousePressEvent(self, event):
        
        self.new_line = None
        
        if self._socket_type == 'out':
            rect = self.boundingRect()
            pointA = self.get_center()
            #pointA = qt.QtCore.QPointF(rect.x() + rect.width(), rect.y() + rect.height()/2)
            #pointA = self.mapToScene(pointA)
            pointB = self.mapToScene(event.pos())
            self.new_line = NodeLine(pointA, pointB)
            self.out_lines.append(self.new_line)
            self.scene().addItem(self.new_line)
        elif self._socket_type == 'in':
            rect = self.boundingRect()
            pointA = self.mapToScene(event.pos())
            #pointB = qt.QtCore.QPointF(rect.x() + rect.width()/2, rect.y() + rect.height()/2)
            pointB = self.get_center()
            #pointB = qt.QtCore.QPointF(rect.x(), rect.y() + rect.height()/2)
            #pointB = self.mapToScene(pointB)
            self.new_line = NodeLine(pointA, pointB)
            self.in_lines.append(self.new_line)
            self.scene().addItem(self.new_line)
            self.new_line.stackAfter()
            #self.new_line.setZValue(10)
        else:
            super(NodeSocket, self).mousePressEvent(event)

        if self.new_line:
            self.scene().disconnect.connect(self._remove_line)

    def mouseMoveEvent(self, event):
        if self._socket_type == 'out':
            pointB = self.mapToScene(event.pos())
            self.new_line.pointB = pointB
        elif self._socket_type == 'in':
            pointA = self.mapToScene(event.pos())
            self.new_line.pointA = pointA
        else:
            super(NodeSocket, self).mouseMoveEvent(event)

    def mouseReleaseEvent(self, event):
        
        self.new_line.hide()
        
        item = self.scene().itemAt(event.scenePos().toPoint(), qt.QTransform())
        
        
        self.new_line.show()
        #if not item:
        #    return
        
        
        
        print 'mouse let go', item
        
        if item == self.new_line or not hasattr(item, '_socket_type'):
            print 'here1'
            self._remove_line(self.new_line)
            self.new_line = None
            return
        if self._socket_type == 'out' and item._socket_type == 'in':
            print 'here2'
            self.new_line.source = self
            self.new_line.target = item
            item.in_lines.append(self.new_line)
            self.new_line.pointB = item.get_center()
            print 'here out in'
        
        elif self._socket_type == 'in' and item._socket_type == 'out':
            print 'here3'
            self.new_line.source = item
            self.new_line.target = self
            item.out_lines.append(self.new_line)
            self.new_line.pointA = item.get_center()
            print 'here in out'
        else:
            print 'here4'
            super(NodeSocket, self).mouseReleaseEvent(event)

    def _remove_line(self, line_item):
        removed = False
        if line_item in self.in_lines:
            self.in_lines.remove(line_item)
            removed = True
        if line_item in self.out_lines:
            self.out_lines.remove(line_item)
            removed = True
        
        if removed:
            self.scene().removeItem(line_item)

    def get_center(self):
        rect = self.boundingRect()

        if self._socket_type == 'out':
            center = qt.QtCore.QPointF(rect.x() + rect.width(), rect.y() + rect.height()/2)      
        if self._socket_type == 'in':
            center = qt.QtCore.QPointF(rect.x() + rect.width()/2, rect.y() + rect.height()/2)
        
        #center = qt.QtCore.QPointF(rect.x() + rect.width()/2, rect.y() + rect.height()/2)
        center = self.mapToScene(center)
        return center   
    
#--- registry

register_item = {
    'FkRig' : FkItem,
    'IkRig' : FkItem,
    'Joints': JointsItem
}